diff --git a/ldap/servers/plugins/replication/cl5_init.c b/ldap/servers/plugins/replication/cl5_init.c
index 112c4ec..318677e 100644
--- a/ldap/servers/plugins/replication/cl5_init.c
+++ b/ldap/servers/plugins/replication/cl5_init.c
@@ -20,12 +20,47 @@
 #include "cl5.h"
 #include "repl5.h"
 
+static int _cl5_upgrade_replica(Replica *replica, void *arg);
+static int _cl5_upgrade_replica_config(Replica *replica, changelog5Config *config);
+static int _cl5_upgrade_removedir(char *path);
+static int _cl5_upgrade_removeconfig(void);
+
+/* upgrade changelog*/
+/* the changelog5 configuration maintained all changlog files in a separate directory
+ * now the changlog is part of the instance database.
+ * If this is the first startup with the new version we willi
+ * - try to move the changelog files for each replica to the instance database.
+ * - create a config entry for trimming and encryption in each backend.
+ */
+int
+changelog5_upgrade(void)
+{
+    int rc = 0;
+    changelog5Config config = {};
+
+    changelog5_read_config(&config);
+
+    if (config.dir == NULL) {
+        /* we do not have a valid legacy config, nothing to upgrade */
+        return rc;
+    }
+
+    replica_enumerate_replicas(_cl5_upgrade_replica, (void *)&config);
+
+    rc = _cl5_upgrade_removedir(config.dir);
+
+    rc = _cl5_upgrade_removeconfig();
+
+    changelog5_config_done(&config);
+
+    return rc;
+}
+
 /* initializes changelog*/
 int
-changelog5_init()
+changelog5_init(void)
 {
     int rc;
-    changelog5Config config;
 
     rc = cl5Init();
     if (rc != CL5_SUCCESS) {
@@ -34,41 +69,22 @@ changelog5_init()
         return 1;
     }
 
-    /* read changelog configuration */
+    /* setup callbacks for operations on changelog */
     changelog5_config_init();
-    changelog5_read_config(&config);
-
-    if (config.dir == NULL) {
-        /* changelog is not configured - bail out */
-        /* Note: but still changelog needs to be initialized to allow it
-         * to configure after this point. (don't call cl5Cleanup) */
-        rc = 0; /* OK */
-        goto done;
-    }
 
     /* start changelog */
-    rc = cl5Open(config.dir, &config.dbconfig);
+    rc = cl5Open();
     if (rc != CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "changelog5_init: failed to start changelog at %s\n",
-                      config.dir);
+                      "changelog5_init: failed to start changelog\n");
         rc = 1;
         goto done;
     }
 
-    /* set trimming parameters */
-    rc = cl5ConfigTrimming(config.maxEntries, config.maxAge, config.compactInterval, config.trimInterval);
-    if (rc != CL5_SUCCESS) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "changelog5_init: failed to configure changelog trimming\n");
-        rc = 1;
-        goto done;
-    }
 
     rc = 0;
 
 done:
-    changelog5_config_done(&config);
     return rc;
 }
 
@@ -83,3 +99,115 @@ changelog5_cleanup()
     /* cleanup config */
     changelog5_config_cleanup();
 }
+static int
+_cl5_upgrade_replica_config(Replica *replica, changelog5Config *config)
+{
+    int rc = 0;
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+
+    Slapi_Entry *config_entry = slapi_entry_alloc();
+    slapi_entry_init(config_entry, slapi_ch_strdup("cn=changelog"), NULL);
+    slapi_entry_add_string(config_entry, "objectclass", "top");
+    slapi_entry_add_string(config_entry, "objectclass", "extensibleObject");
+
+    /* keep the changelog trimming config */
+    if (config->maxEntries) {
+        char *maxEnt = slapi_ch_smprintf("%d", config->maxEntries);
+        slapi_entry_add_string(config_entry, CONFIG_CHANGELOG_MAXENTRIES_ATTRIBUTE, maxEnt);
+    }
+    if (strcmp(config->maxAge, CL5_STR_IGNORE)) {
+        slapi_entry_add_string(config_entry, CONFIG_CHANGELOG_MAXAGE_ATTRIBUTE, config->maxAge);
+    }
+    if (config->trimInterval != CHANGELOGDB_TRIM_INTERVAL) {
+        /* char *interval = slapi_ch_smprintf("%ld", config->trimInterval); */
+        slapi_entry_add_string(config_entry, CONFIG_CHANGELOG_TRIM_ATTRIBUTE, gen_duration(config->trimInterval));
+    }
+
+    /* if changelog encryption is enabled then in the upgrade mode all backends will have 
+     * an encrypted changelog, store the encryption attrs */
+
+    if (config->encryptionAlgorithm) {
+        slapi_entry_add_string(config_entry, CONFIG_CHANGELOG_ENCRYPTION_ALGORITHM, config->encryptionAlgorithm);
+        slapi_entry_add_string(config_entry, CONFIG_CHANGELOG_SYMMETRIC_KEY, config->symmetricKey);
+    }
+    rc = slapi_back_ctrl_info(be, BACK_INFO_CLDB_SET_CONFIG, (void *)config_entry);
+
+    return rc;
+}
+static int
+_cl5_upgrade_replica(Replica *replica, void *arg)
+{
+    int rc = 0;
+    changelog5Config *config = (changelog5Config *)arg;
+
+    /* Move existing database file to backend */
+    char *replGen = replica_get_generation (replica);
+    const char *replName = replica_get_name (replica);
+    char *oldFile = slapi_ch_smprintf("%s/%s_%s.db",
+                                       config->dir, replName, replGen);
+    slapi_ch_free_string(&replGen);
+    if (PR_Access(oldFile, PR_ACCESS_EXISTS) == PR_SUCCESS) {
+        Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+        char *instancedir;
+        slapi_back_get_info(be, BACK_INFO_INSTANCE_DIR, (void **)&instancedir);
+        char *newFile = slapi_ch_smprintf("%s/changelog.db", instancedir);
+
+        rc = slapi_back_ctrl_info(be, BACK_INFO_DBENV_CLDB_UPGRADE, oldFile);
+        slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name_cl,
+                      "_cl5_upgrade_replica: moving file (%s) to (%s) %s\n",
+                      oldFile, newFile, rc?"failed":"succeeded");
+        slapi_ch_free_string(&instancedir);
+    }
+
+    /* Move changelog config to backend config */
+    rc = _cl5_upgrade_replica_config(replica, config);
+
+    return rc;
+}
+static int
+_cl5_upgrade_removedir(char *path)
+{
+    /* this is duplicated from ldbm_delete_dirs, we unfortunately
+     * cannot access the backend functions
+     */
+    PRDir *dirhandle = NULL;
+    PRDirEntry *direntry = NULL;
+    char fullpath[MAXPATHLEN];
+    int rval = 0;
+    PRFileInfo64 info;
+
+    dirhandle = PR_OpenDir(path);
+    if (!dirhandle) {
+        PR_Delete(path);
+        return 0;
+    }
+
+    while (NULL != (direntry =
+                        PR_ReadDir(dirhandle, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
+        if (!direntry->name)
+            break;
+
+        PR_snprintf(fullpath, MAXPATHLEN, "%s/%s", path, direntry->name);
+        rval = PR_GetFileInfo64(fullpath, &info);
+        if (PR_SUCCESS == rval) {
+            PR_Delete(fullpath);
+        }
+    }
+    PR_CloseDir(dirhandle);
+    /* remove the directory itself too */
+    rval += PR_RmDir(path);
+    return rval;
+}
+static int
+_cl5_upgrade_removeconfig(void)
+{
+    int rc = LDAP_SUCCESS;
+
+    Slapi_PBlock *pb = slapi_pblock_new();
+    slapi_delete_internal_set_pb(pb, "cn=changelog5,cn=config", NULL, NULL,
+                                 repl_get_plugin_identity(PLUGIN_MULTIMASTER_REPLICATION), 0);
+    slapi_delete_internal_pb(pb);
+    slapi_pblock_get(pb, SLAPI_PLUGIN_INTOP_RESULT, &rc);
+    slapi_pblock_destroy(pb);
+    return rc;
+}
diff --git a/ldap/servers/plugins/replication/cl5_test.c b/ldap/servers/plugins/replication/cl5_test.c
index d665665..b9be936 100644
--- a/ldap/servers/plugins/replication/cl5_test.c
+++ b/ldap/servers/plugins/replication/cl5_test.c
@@ -29,7 +29,6 @@
 static void testBasic();
 static void testBackupRestore();
 static void testIteration();
-static void testTrimming();
 static void testPerformance();
 static void testPerformanceMT();
 static void testLDIF();
@@ -57,9 +56,6 @@ testChangelog(TestType type)
     case TEST_ITERATION:
         testIteration();
         break;
-    case TEST_TRIMMING:
-        testTrimming();
-        break;
     case TEST_PERFORMANCE:
         testPerformance();
         break;
@@ -115,7 +111,7 @@ testBackupRestore()
 
     slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "Starting backup and recovery test ...\n");
 
-    dir = cl5GetDir();
+    dir = cl5GetLdifDir(NULL);
 
     if (dir) {
         baseDir = getBaseDir(dir);
@@ -127,7 +123,7 @@ testBackupRestore()
             cl5Close();
             rc = cl5Restore(dir, bkDir, NULL);
             if (rc == CL5_SUCCESS)
-                rc = cl5Open(dir, NULL);
+                rc = cl5Open();
 
             /* PR_RmDir (bkDir);*/
         }
@@ -264,45 +260,6 @@ testIteration()
 }
 
 static void
-testTrimming()
-{
-    PRIntervalTime interval;
-    int count;
-    int rc;
-
-    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "Starting trimming test ...\n");
-
-    rc = populateChangelog(200, NULL);
-
-    if (rc == 0) {
-        interval = PR_SecondsToInterval(2);
-        DS_Sleep(interval);
-
-        rc = populateChangelog(300, NULL);
-
-        if (rc == 0)
-            rc = cl5ConfigTrimming(300, "1d", CHANGELOGDB_COMPACT_INTERVAL, CHANGELOGDB_TRIM_INTERVAL);
-
-        interval = PR_SecondsToInterval(300); /* 5 min is default trimming interval */
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "Trimming test: sleeping for 5 minutes until trimming kicks in\n");
-        DS_Sleep(interval);
-
-        count = cl5GetOperationCount(NULL);
-    }
-
-    if (rc == 0 && count == 300) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "Trimming test completed successfully: changelog contains 300 entries\n");
-    } else if (rc == 0) {
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                      "Trimming test failed: changelog contains %d entries; expected - 300\n",
-                      count);
-    } else /* general failure */
-        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl, "Trimming test failed\n");
-}
-
-static void
 testPerformance()
 {
     PRTime starttime, endtime, totaltime;
@@ -393,7 +350,7 @@ testPerformanceMT()
 static void
 testLDIF()
 {
-    char *clDir = cl5GetDir();
+    char *clDir = cl5GetLdifDir(NULL);
     int rc;
     char *baseDir;
     char ldifFile[MAXPATHLEN];
@@ -411,7 +368,7 @@ testLDIF()
             cl5Close();
             rc = cl5ImportLDIF(clDir, ldifFile, NULL);
             if (rc == CL5_SUCCESS)
-                cl5Open(clDir, NULL);
+                cl5Open();
         }
     }
 
@@ -435,20 +392,6 @@ testAll()
 
     testLDIF();
 
-/* testTrimming ();*/
-
-#if 0
-    /* xxxPINAKI */
-    /* these tests are not working correctly...the call to db->put() */
-    /* just hangs forever */
-    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                    "Starting single threaded performance measurement ...\n");
-    testPerformance ();
-
-    slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
-                    "Starting multi threaded performance measurement ...\n");
-    testPerformanceMT ();
-#endif
 }
 
 static int
diff --git a/ldap/servers/plugins/replication/cl_crypt.c b/ldap/servers/plugins/replication/cl_crypt.c
index 8385534..340e3e3 100644
--- a/ldap/servers/plugins/replication/cl_crypt.c
+++ b/ldap/servers/plugins/replication/cl_crypt.c
@@ -29,44 +29,33 @@
 /*
  * BACK_INFO_CRYPT_INIT
  */
-int
-clcrypt_init(const CL5DBConfig *config, void **clcrypt_handle)
+void *
+clcrypt_init(char *encryptionAlgorithm, Slapi_Backend *be)
 {
     int rc = 0;
-    char *cookie = NULL;
-    Slapi_Backend *be = NULL;
     back_info_crypt_init crypt_init = {0};
+    void *crypt_handle = NULL;
 
     slapi_log_err(SLAPI_LOG_TRACE, repl_plugin_name, "-> clcrypt_init\n");
-    /* Encryption is not specified */
-    if (!config->encryptionAlgorithm || !clcrypt_handle) {
+
+    if (!encryptionAlgorithm) {
+        /* Encryption is not specified */
         goto bail;
     }
-    crypt_init.dn = "cn=changelog5,cn=config";
-    crypt_init.encryptionAlgorithm = config->encryptionAlgorithm;
+    crypt_init.dn = "cn=changelog";
+    crypt_init.encryptionAlgorithm = encryptionAlgorithm;
+    crypt_init.be = be;
 
-    be = slapi_get_first_backend(&cookie);
-    while (be) {
-        crypt_init.be = be;
-        rc = slapi_back_ctrl_info(be, BACK_INFO_CRYPT_INIT,
+    rc = slapi_back_ctrl_info(be, BACK_INFO_CRYPT_INIT,
                                   (void *)&crypt_init);
-        if (LDAP_SUCCESS == rc) {
-            break; /* Successfully fetched */
-        }
-        be = slapi_get_next_backend(cookie);
-    }
-    slapi_ch_free((void **)&cookie);
 
     if (LDAP_SUCCESS == rc && crypt_init.state_priv) {
-        *clcrypt_handle = crypt_init.state_priv;
-        rc = 0;
-    } else {
-        rc = 1;
+        crypt_handle = crypt_init.state_priv;
     }
 bail:
     slapi_log_err(SLAPI_LOG_TRACE, repl_plugin_name,
                   "<- clcrypt_init : %d\n", rc);
-    return rc;
+    return crypt_handle;
 }
 
 /*
@@ -77,38 +66,26 @@ bail:
  *                  :     NULL - failure
  */
 int
-clcrypt_destroy(void *clcrypt_handle)
+clcrypt_destroy(void *clcrypt_handle, Slapi_Backend *be)
 {
     int rc = -1;
-    char *cookie = NULL;
-    Slapi_Backend *be = NULL;
     back_info_crypt_destroy crypt_destroy = {0};
 
     slapi_log_err(SLAPI_LOG_TRACE, repl_plugin_name,
                   "-> clcrypt_destroy\n");
     if (NULL == clcrypt_handle) {
         /* Nothing to free */
-        rc = 0;
-        goto bail;
+        return 0;
     }
     crypt_destroy.state_priv = clcrypt_handle;
 
-    be = slapi_get_first_backend(&cookie);
-    while (be) {
-        rc = slapi_back_ctrl_info(be, BACK_INFO_CRYPT_DESTROY,
-                                  (void *)&crypt_destroy);
-        if (LDAP_SUCCESS == rc) {
-            break; /* Successfully freed */
-        }
-        be = slapi_get_next_backend(cookie);
-    }
-    slapi_ch_free((void **)&cookie);
+    rc = slapi_back_ctrl_info(be, BACK_INFO_CRYPT_DESTROY,
+                              (void *)&crypt_destroy);
     if (LDAP_SUCCESS == rc) {
         rc = 0;
     } else {
         rc = -1;
     }
-bail:
     slapi_log_err(SLAPI_LOG_TRACE, repl_plugin_name,
                   "<- clcrypt_destroy (returning %d)\n", rc);
     return rc;
diff --git a/ldap/servers/plugins/replication/cl_crypt.h b/ldap/servers/plugins/replication/cl_crypt.h
index 9b69052..6632544 100644
--- a/ldap/servers/plugins/replication/cl_crypt.h
+++ b/ldap/servers/plugins/replication/cl_crypt.h
@@ -18,8 +18,8 @@
 #include "nss.h"
 #include "cert.h"
 
-int clcrypt_init(const CL5DBConfig *config, void **clcrypt_handle);
-int clcrypt_destroy(void *clcrypt_handle);
+void *clcrypt_init(char *encryptionAlgorithm, Slapi_Backend *be);
+int clcrypt_destroy(void *clcrypt_handle, Slapi_Backend *be);
 int clcrypt_encrypt_value(void *clcrypt_handle, struct berval *in, struct berval **out);
 int clcrypt_decrypt_value(void *state_priv, struct berval *in, struct berval **out);
 #endif /* _CLCRYPT_H_ */
diff --git a/ldap/servers/plugins/replication/repl5.h b/ldap/servers/plugins/replication/repl5.h
index 79353e0..3518bfe 100644
--- a/ldap/servers/plugins/replication/repl5.h
+++ b/ldap/servers/plugins/replication/repl5.h
@@ -753,6 +753,8 @@ PRBool ignore_error_and_keep_going(int error);
 void replica_check_release_timeout(Replica *r, Slapi_PBlock *pb);
 void replica_lock_replica(Replica *r);
 void replica_unlock_replica(Replica *r);
+void *replica_get_file_info(Replica *r);
+int replica_set_file_info(Replica *r, void *cl);
 
 /* The functions below handles the state flag */
 /* Current internal state flags */
@@ -808,8 +810,7 @@ typedef struct _cleanruv_purge_data
 {
     int cleaned_rid;
     const Slapi_DN *suffix_sdn;
-    char *replName;
-    char *replGen;
+    Replica *replica;
 } cleanruv_purge_data;
 
 typedef struct _csngen_test_data
diff --git a/ldap/servers/plugins/replication/repl5_init.c b/ldap/servers/plugins/replication/repl5_init.c
index 5a748e3..5a6ae99 100644
--- a/ldap/servers/plugins/replication/repl5_init.c
+++ b/ldap/servers/plugins/replication/repl5_init.c
@@ -338,8 +338,8 @@ multimaster_bepreop_init(Slapi_PBlock *pb)
 
     if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION, (void *)&multimasterbepreopdesc) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_CLOSE_FN, (void *)cl5Cleanup) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_BACKUP_FN, (void *)cl5WriteRUV) != 0) {
+        /* slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_CLOSE_FN, (void *)cl5Cleanup) != 0) { */
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_PRE_CLOSE_FN, (void *)cl5Close) != 0) {
         slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name, "multimaster_bepreop_init - Failed\n");
         rc = -1;
     }
@@ -385,10 +385,9 @@ multimaster_bepostop_init(Slapi_PBlock *pb)
 
     if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION, (void *)&multimasterbepostopdesc) != 0 ||
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_OPEN_FN, (void *)cl5Open) != 0 ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_MODRDN_FN, (void *)multimaster_bepostop_modrdn) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_DELETE_FN, (void *)multimaster_bepostop_delete) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_OPEN_FN, (void *)changelog5_init) != 0 ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_BACKUP_FN, (void *)cl5DeleteRUV) != 0) {
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_DELETE_FN, (void *)multimaster_bepostop_delete) != 0) {
         slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name, "multimaster_bepostop_init - Failed\n");
         rc = -1;
     }
@@ -408,8 +407,9 @@ multimaster_betxn_bepostop_init(Slapi_PBlock *pb)
 
     if (slapi_pblock_set(pb, SLAPI_PLUGIN_VERSION, SLAPI_PLUGIN_VERSION_01) ||
         slapi_pblock_set(pb, SLAPI_PLUGIN_DESCRIPTION, (void *)&multimasterbepostopdesc) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_OPEN_FN, (void *)changelog5_init) ||
-        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_BACKUP_FN, (void *)cl5DeleteRUV)) {
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_OPEN_FN, (void *)cl5Open) != 0 ||
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_EXPORT_FN, (void *)cl5Export) ||
+        slapi_pblock_set(pb, SLAPI_PLUGIN_BE_POST_IMPORT_FN, (void *)cl5Import)) {
         slapi_log_err(SLAPI_LOG_PLUGIN, repl_plugin_name, "multimaster_betxn_bepostop_init - Failed\n");
         rc = -1;
     }
@@ -797,17 +797,16 @@ multimaster_start(Slapi_PBlock *pb)
         /* create replicas */
         multimaster_mtnode_construct_replicas();
 
-        /* Initialise the 5.0 Changelog */
+        /* Upgrade the 5.0 Changelog if it still exists */
+        rc = changelog5_upgrade();
+        if (rc != 0)
+            goto out;
+
+        /* perform initial changelog setup */
         rc = changelog5_init();
         if (rc != 0)
             goto out;
 
-        /* Initialize the replication agreements, unless we're dumping LDIF */
-        if (!is_ldif_dump) {
-            rc = agmtlist_config_init();
-            if (rc != 0)
-                goto out;
-        }
         rc = create_repl_schema_policy();
         if (rc != 0)
             goto out;
@@ -815,9 +814,14 @@ multimaster_start(Slapi_PBlock *pb)
         /* check if the replica's data was reloaded offline and we need
            to reinitialize replica's changelog. This should be done
            after the changelog is initialized */
-
         replica_enumerate_replicas(replica_check_for_data_reload, NULL);
 
+        /* Initialize the replication agreements, unless we're dumping LDIF */
+        if (!is_ldif_dump) {
+            rc = agmtlist_config_init();
+            if (rc != 0)
+                goto out;
+        }
         /* register to be notified when backend state changes */
         slapi_register_backend_state_change((void *)multimaster_be_state_change,
                                             multimaster_be_state_change);
diff --git a/ldap/servers/plugins/replication/repl5_plugins.c b/ldap/servers/plugins/replication/repl5_plugins.c
index caa99d1..115dc3f 100644
--- a/ldap/servers/plugins/replication/repl5_plugins.c
+++ b/ldap/servers/plugins/replication/repl5_plugins.c
@@ -987,19 +987,15 @@ write_changelog_and_ruv(Slapi_PBlock *pb)
 
     replica_check_release_timeout(r, pb);
 
-    if (replica_is_flag_set(r, REPLICA_LOG_CHANGES) &&
-        (cl5GetState() == CL5_STATE_OPEN)) {
+    if (replica_is_flag_set(r, REPLICA_LOG_CHANGES)) {
         supplier_operation_extension *opext = NULL;
-        const char *repl_name;
-        char *repl_gen;
+        cldb_Handle *cldb  = NULL;
 
         opext = (supplier_operation_extension *)repl_sup_get_ext(REPL_SUP_EXT_OP, op);
         PR_ASSERT(opext);
 
-        /* get replica generation and replica name to pass to the write function */
-        repl_name = replica_get_name(r);
-        repl_gen = opext->repl_gen;
-        PR_ASSERT(repl_name && repl_gen);
+        /* changelog database information to pass to the write function */
+        cldb = replica_get_file_info(r);
 
         /* for replicated operations, we log the original, non-urp data which is
            saved in the operation extension */
@@ -1061,11 +1057,6 @@ write_changelog_and_ruv(Slapi_PBlock *pb)
             op_params->p.p_modify.modify_mods != NULL) {
             void *txn = NULL;
             char csn_str[CSN_STRSIZE];
-            if (cl5_is_diskfull() && !cl5_diskspace_is_available()) {
-                slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name,
-                              "write_changelog_and_ruv - Skipped due to DISKFULL\n");
-                goto common_return;
-            }
             slapi_pblock_get(pb, SLAPI_TXN, &txn);
             slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name,
                           "write_changelog_and_ruv - Writing change for "
@@ -1074,8 +1065,7 @@ write_changelog_and_ruv(Slapi_PBlock *pb)
                           op_params->target_address.uniqueid,
                           op_params->operation_type,
                           csn_as_string(op_params->csn, PR_FALSE, csn_str));
-            rc = cl5WriteOperationTxn(repl_name, repl_gen, op_params,
-                                      !operation_is_flag_set(op, OP_FLAG_REPLICATED), txn);
+            rc = cl5WriteOperationTxn(cldb, op_params, txn);
             if (rc != CL5_SUCCESS) {
                 /* ONREPL - log error */
                 slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name,
diff --git a/ldap/servers/plugins/replication/repl5_replica.c b/ldap/servers/plugins/replication/repl5_replica.c
index 02caa88..c556070 100644
--- a/ldap/servers/plugins/replication/repl5_replica.c
+++ b/ldap/servers/plugins/replication/repl5_replica.c
@@ -66,6 +66,7 @@ struct replica
     uint64_t agmt_count;               /* Number of agmts */
     Slapi_Counter *release_timeout;    /* The amount of time to wait before releasing active replica */
     uint64_t abort_session;            /* Abort the current replica session */
+    cldb_Handle *cldb;                 /* database info for the changelog */
 };
 
 
@@ -84,6 +85,7 @@ static Slapi_Entry *_replica_get_config_entry(const Slapi_DN *root, const char *
 static int _replica_check_validity(const Replica *r);
 static int _replica_init_from_config(Replica *r, Slapi_Entry *e, char *errortext);
 static int _replica_update_entry(Replica *r, Slapi_Entry *e, char *errortext);
+static int _replica_config_changelog(Replica *r);
 static int _replica_configure_ruv(Replica *r, PRBool isLocked);
 static char *_replica_get_config_dn(const Slapi_DN *root);
 static char *_replica_type_as_string(const Replica *r);
@@ -205,6 +207,7 @@ replica_new_from_entry(Slapi_Entry *e, char *errortext, PRBool is_add_operation,
         rc = LDAP_SUCCESS;
     }
 
+
     /* If smallest csn exists in RUV for our local replica, it's ok to begin iteration */
     PR_ASSERT(object_get_data(r->repl_ruv));
 
@@ -215,6 +218,16 @@ replica_new_from_entry(Slapi_Entry *e, char *errortext, PRBool is_add_operation,
          * during replica initialization
          */
         rc = _replica_update_entry(r, e, errortext);
+        /* add changelog config entry to config 
+         * this is only needed for replicas logging changes,
+         * but for now let it exist for all replicas. Makes handling
+         * of changing replica flags easier
+         */
+        _replica_config_changelog(r);
+        if (r->repl_flags & REPLICA_LOG_CHANGES) {
+            /* Init changelog db file */
+            cldb_SetReplicaDB(r, NULL);
+        }
     } else {
         /*
          * Entry is already in dse.ldif - update it on the disk
@@ -795,6 +808,10 @@ replica_set_ruv(Replica *r, RUV *ruv)
 
     r->repl_ruv = object_new((void *)ruv, (FNFree)ruv_destroy);
 
+    if (r->repl_flags & REPLICA_LOG_CHANGES) {
+        cl5NotifyRUVChange(r);
+    }
+
     replica_unlock(r->repl_lock);
 }
 
@@ -1553,12 +1570,20 @@ replica_reload_ruv(Replica *r)
                                                                    " Recreating the changelog file. This could affect replication with replica's "
                                                                    " consumers in which case the consumers should be reinitialized.\n",
                               slapi_sdn_get_dn(r->repl_root));
-                rc = cl5DeleteDBSync(r);
+
+                /* need to reset changelog db */
+                rc = cldb_RemoveReplicaDB(r);
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                     "replica_reload_ruv: reset cldb for replica\n");
 
                 /* reinstate new ruv */
                 replica_lock(r->repl_lock);
 
                 r->repl_ruv = new_ruv_obj;
+                slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                    "replica_reload_ruv: set cldb for replica\n");
+
+                cldb_SetReplicaDB(r, NULL);
 
                 if (rc == CL5_SUCCESS) {
                     /* log changes to mark starting point for replication */
@@ -1685,7 +1710,10 @@ replica_check_for_data_reload(Replica *r, void *arg __attribute__((unused)))
                                                                        "consumers should be reinitialized.\n",
                                   slapi_sdn_get_dn(r->repl_root));
 
-                    rc = cl5DeleteDBSync(r);
+
+                    /* need to reset changelog db */
+                    rc = cldb_RemoveReplicaDB(r);
+                    cldb_SetReplicaDB(r, NULL);
 
                     if (rc == CL5_SUCCESS) {
                         /* log changes to mark starting point for replication */
@@ -2409,6 +2437,26 @@ _replica_get_config_dn(const Slapi_DN *root)
                            REPLICA_RDN, slapi_sdn_get_dn(root), mp_base);
     return dn;
 }
+/* when a replica is added the changelog config entry is created
+ * it will only the container entry, specifications for trimming 
+ * or encyrption need to be added separately
+ */
+static int
+_replica_config_changelog(Replica *replica)
+{
+    int rc = 0;
+
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+
+    Slapi_Entry *config_entry = slapi_entry_alloc();
+    slapi_entry_init(config_entry, slapi_ch_strdup("cn=changelog"), NULL);
+    slapi_entry_add_string(config_entry, "objectclass", "top");
+    slapi_entry_add_string(config_entry, "objectclass", "extensibleObject");
+
+    rc = slapi_back_ctrl_info(be, BACK_INFO_CLDB_SET_CONFIG, (void *)config_entry);
+
+    return rc;
+}
 
 /* This function retrieves RUV from the root of the replicated tree.
  * The attribute can be missing if
@@ -3499,18 +3547,13 @@ replica_get_referrals_nolock(const Replica *r, char ***referrals)
     }
 }
 
-typedef struct replinfo
-{
-    char *repl_gen;
-    char *repl_name;
-} replinfo;
-
 static int
 replica_log_start_iteration(const ruv_enum_data *rid_data, void *data)
 {
     int rc = 0;
-    replinfo *r_info = (replinfo *)data;
     slapi_operation_parameters op_params;
+    Replica *replica = (Replica *)data;
+    cldb_Handle *cldb = NULL;
 
     if (rid_data->csn == NULL)
         return 0;
@@ -3520,7 +3563,8 @@ replica_log_start_iteration(const ruv_enum_data *rid_data, void *data)
     op_params.target_address.sdn = slapi_sdn_new_ndn_byval(START_ITERATION_ENTRY_DN);
     op_params.target_address.uniqueid = START_ITERATION_ENTRY_UNIQUEID;
     op_params.csn = csn_dup(rid_data->csn);
-    rc = cl5WriteOperation(r_info->repl_name, r_info->repl_gen, &op_params, PR_FALSE);
+    cldb = replica_get_file_info(replica);
+    rc = cl5WriteOperation(cldb, &op_params);
     if (rc == CL5_SUCCESS)
         rc = 0;
     else
@@ -3537,8 +3581,6 @@ replica_log_ruv_elements_nolock(const Replica *r)
 {
     int rc = 0;
     RUV *ruv;
-    char *repl_gen;
-    replinfo r_info;
 
     ruv = (RUV *)object_get_data(r->repl_ruv);
     PR_ASSERT(ruv);
@@ -3546,15 +3588,7 @@ replica_log_ruv_elements_nolock(const Replica *r)
     /* we log it as a delete operation to have the least number of fields
            to set. the entry can be identified by a special target uniqueid and
            special target dn */
-    repl_gen = ruv_get_replica_generation(ruv);
-
-    r_info.repl_name = r->repl_name;
-    r_info.repl_gen = repl_gen;
-
-    rc = ruv_enumerate_elements(ruv, replica_log_start_iteration, &r_info);
-
-    slapi_ch_free((void **)&repl_gen);
-
+    rc = ruv_enumerate_elements(ruv, replica_log_start_iteration, (void *)r);
     return rc;
 }
 
@@ -3777,6 +3811,9 @@ replica_enable_replication(Replica *r)
 
     /* prevent creation of new agreements until the replica is enabled */
     PR_Lock(r->agmt_lock);
+    if (r->repl_flags & REPLICA_LOG_CHANGES) {
+        cldb_SetReplicaDB(r, NULL);
+    }
 
     /* retrieve new ruv */
     rc = replica_reload_ruv(r);
@@ -3863,6 +3900,12 @@ replica_disable_replication(Replica *r)
     slapi_ch_free_string(&locking_purl);
     replica_set_state_flag(r, REPLICA_AGREEMENTS_DISABLED, PR_FALSE);
     PR_Unlock(r->agmt_lock);
+    /* no thread will access the changelog for this replica
+     * remove reference from replica object
+     */
+    if (r->repl_flags & REPLICA_LOG_CHANGES) {
+        cldb_UnSetReplicaDB(r, NULL);
+    }
 
     slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name, "replica_disable_replication - "
                                                     "replica %s is acquired\n",
@@ -4140,3 +4183,12 @@ replica_unlock_replica(Replica *r)
 {
     replica_unlock(r->repl_lock);
 }
+void* replica_get_file_info(Replica *r)
+{
+       return r->cldb;
+}
+int replica_set_file_info(Replica *r, void *cl)
+{
+       r->cldb = (cldb_Handle *)cl;
+       return 0;
+}
